
CoCoALib - Bug #1248

MinPolyQuot: guaranteed and ideal without GBasis

01 Mar 2019 17:14 - John Abbott

Status: Closed Start date: 01 Mar 2019

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Maths Bugs Estimated time: 0.00 hour

Target version: CoCoALib-0.99650 November 2019 Spent time: 1.60 hour

Description

Today we noticed that ex-Verification1 failed.  What happened is that MinPolyQuot was called with a (principal) ideal without a

G-basis.  Comparison was made between the result obtained with VerificationLevel set to 0, set to 2 and set to "guaranteed".

The answer was wrong with "guaranteed".

Fix this!

Related issues:

Related to CoCoA-5 - Support #1240: John's visit Feb 2019 Closed 08 Feb 2019

Related to CoCoALib - Design #849: Cleanup MinPoly code In Progress 22 Mar 2016

History

#1 - 01 Mar 2019 17:20 - John Abbott

The cause was an incompatibility:

(A) if the ideal supplied has no G-basis then verification was disabled (since verification would entail computing a G-basis, which might be very

costly)

(B) if the VerificationLevel is set to guaranteed then the result should always be correct.

Anna asks what should happen of the caller does not specify what VerificationLevel to use?  Previously the heuristic (A) was used.

#2 - 01 Mar 2019 17:26 - John Abbott

- Related to Support #1240: John's visit Feb 2019 added

#3 - 05 Mar 2019 15:54 - John Abbott

- Related to Feature #1103: Pseudo-zero-dim ideals added

#4 - 05 Mar 2019 16:08 - John Abbott

For min polys it might be possible to work with a sub-ideal in a subring.  For example,

use QQ[x,y,z,t];

I := ideal(x^2-2, y^3-3, z^5-5);

f := x+y;

MinPolyQuot(f,I,x);

 

------ this comment has been converted into Feature #1254 ------
https://cocoa.dima.unige.it/redmine/issues/1254


#5 - 05 Mar 2019 16:13 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Two more comments:

(1) my preference is that computations in CoCoALib be guaranteed correct unless the caller explicitly says otherwise (e.g. by specifying a finite

VerificationLevel).

(2) I forgot to mention that in the case that a guaranteed answer is desired and the ideal has no GBasis, MinPolyQuot could perhaps map the

ideal into another ring with DegRevLex, and compute the min poly there (because computing a GBasis in the original ring might be costly if the

term-ordering is inconvenient)

#6 - 05 Mar 2019 16:40 - John Abbott

The CoCoA-5 test test-ApproxSolve.cocoa5 failed with wrong output: there should have been no output, instead a warning about "no precomputed

GBasis" is printed 88 times!

This should be fixed.

#7 - 06 Mar 2019 16:34 - Anna Maria Bigatti

Fixed.

Now, guaranteed computes GBasis if missing, so result is guaranteed.

Testing.

#8 - 06 Mar 2019 16:37 - Anna Maria Bigatti

- % Done changed from 10 to 70

#9 - 06 Mar 2019 16:46 - Anna Maria Bigatti

- Related to deleted (Feature #1103: Pseudo-zero-dim ideals)

#10 - 01 Oct 2019 12:15 - John Abbott

- Assignee set to Anna Maria Bigatti

We should either close this issue (almost immediately), or postpone it (to 0.99700?).

#11 - 01 Oct 2019 12:16 - John Abbott

- Related to Design #849: Cleanup MinPoly code added

#12 - 03 Oct 2019 15:43 - Anna Maria Bigatti

- Status changed from In Progress to Feedback

- % Done changed from 70 to 90

I think this is all done now: #1248-6

Also the principal ideal has been dealt with: #1249

#13 - 31 Oct 2019 15:55 - Anna Maria Bigatti

- Status changed from Feedback to Closed
https://cocoa.dima.unige.it/redmine/issues/1248#note-6
https://cocoa.dima.unige.it/redmine/issues/1249


- % Done changed from 90 to 100
